dojo.provide("dojo.widget.Chart");
dojo.require("dojo.widget.*");
dojo.require("dojo.gfx.color");
dojo.require("dojo.gfx.color.hsl");
dojo.declare("dojo.widget.Chart",null,function(){
this.series=[];
},{isContainer:false,assignColors:function(){
var _1=30;
var _2=120;
var _3=120;
var _4=Math.round(330/this.series.length);
for(var i=0;i<this.series.length;i++){
var c=dojo.gfx.color.hsl2rgb(_1,_2,_3);
if(!this.series[i].color){
this.series[i].color=dojo.gfx.color.rgb2hex(c[0],c[1],c[2]);
}
_1+=_4;
}
},parseData:function(_7){
var _8=_7.getElementsByTagName("thead")[0];
var _9=_7.getElementsByTagName("tbody")[0];
if(!(_8&&_9)){
dojo.raise("dojo.widget.Chart: supplied table must define a head and a body.");
}
var _a=_8.getElementsByTagName("tr")[0].getElementsByTagName("th");
for(var i=1;i<_a.length;i++){
var _c="column"+i;
var _d=_a[i].innerHTML;
var _e=_a[i].getAttribute("plotType")||"line";
var _f=_a[i].getAttribute("color");
var ds=new dojo.widget.Chart.DataSeries(_c,_d,_e,_f);
this.series.push(ds);
}
var _11=_9.rows;
var _12=Number.MAX_VALUE,xMax=Number.MIN_VALUE;
var _13=Number.MAX_VALUE,yMax=Number.MIN_VALUE;
var _14=["accesskey","align","bgcolor","class","colspan","height","id","nowrap","rowspan","style","tabindex","title","valign","width"];
for(var i=0;i<_11.length;i++){
var row=_11[i];
var _16=row.cells;
var x=Number.MIN_VALUE;
for(var j=0;j<_16.length;j++){
if(j==0){
x=parseFloat(_16[j].innerHTML);
_12=Math.min(_12,x);
xMax=Math.max(xMax,x);
}else{
var ds=this.series[j-1];
var y=parseFloat(_16[j].innerHTML);
_13=Math.min(_13,y);
yMax=Math.max(yMax,y);
var o={x:x,value:y};
var _1b=_16[j].attributes;
for(var k=0;k<_1b.length;k++){
var _1d=_1b.item(k);
var _1e=false;
for(var l=0;l<_14.length;l++){
if(_1d.nodeName.toLowerCase()==_14[l]){
_1e=true;
break;
}
}
if(!_1e){
o[_1d.nodeName]=_1d.nodeValue;
}
}
ds.add(o);
}
}
}
return {x:{min:_12,max:xMax},y:{min:_13,max:yMax}};
}});
dojo.declare("dojo.widget.Chart.DataSeries",null,function(key,_21,_22,_23){
this.id="DataSeries"+dojo.widget.Chart.DataSeries.count++;
this.key=key;
this.label=_21||this.id;
this.plotType=_22||"line";
this.color=_23;
this.values=[];
},{add:function(v){
if(v.x==null||v.value==null){
dojo.raise("dojo.widget.Chart.DataSeries.add: v must have both an 'x' and 'value' property.");
}
this.values.push(v);
},clear:function(){
this.values=[];
},createRange:function(len){
var idx=this.values.length-1;
var _27=(len||this.values.length);
return {"index":idx,"length":_27,"start":Math.max(idx-_27,0)};
},getMean:function(len){
var _29=this.createRange(len);
if(_29.index<0){
return 0;
}
var t=0;
var c=0;
for(var i=_29.index;i>=_29.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t+=n;
c++;
}
}
t/=Math.max(c,1);
return t;
},getMovingAverage:function(len){
var _2f=this.createRange(len);
if(_2f.index<0){
return 0;
}
var t=0;
var c=0;
for(var i=_2f.index;i>=_2f.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t+=n;
c++;
}
}
t/=Math.max(c,1);
return t;
},getVariance:function(len){
var _35=this.createRange(len);
if(_35.index<0){
return 0;
}
var t=0;
var s=0;
var c=0;
for(var i=_35.index;i>=_35.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t+=n;
s+=Math.pow(n,2);
c++;
}
}
return (s/c)-Math.pow(t/c,2);
},getStandardDeviation:function(len){
return Math.sqrt(this.getVariance(len));
},getMax:function(len){
var _3d=this.createRange(len);
if(_3d.index<0){
return 0;
}
var t=0;
for(var i=_3d.index;i>=_3d.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t=Math.max(n,t);
}
}
return t;
},getMin:function(len){
var _42=this.createRange(len);
if(_42.index<0){
return 0;
}
var t=0;
for(var i=_42.index;i>=_42.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
t=Math.min(n,t);
}
}
return t;
},getMedian:function(len){
var _47=this.createRange(len);
if(_47.index<0){
return 0;
}
var a=[];
for(var i=_47.index;i>=_47.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
var b=false;
for(var j=0;j<a.length&&!b;j++){
if(n==a[j]){
b=true;
}
}
if(!b){
a.push(n);
}
}
}
a.sort();
if(a.length>0){
return a[Math.ceil(a.length/2)];
}
return 0;
},getMode:function(len){
var _4e=this.createRange(len);
if(_4e.index<0){
return 0;
}
var o={};
var ret=0;
var m=0;
for(var i=_4e.index;i>=_4e.start;i--){
var n=parseFloat(this.values[i].value);
if(!isNaN(n)){
if(!o[this.values[i].value]){
o[this.values[i].value]=1;
}else{
o[this.values[i].value]++;
}
}
}
for(var p in o){
if(m<o[p]){
m=o[p];
ret=p;
}
}
return parseFloat(ret);
}});
dojo["requireIf"](dojo.render.svg.capable,"dojo.widget.svg.Chart");
dojo["requireIf"](!dojo.render.svg.capable&&dojo.render.vml.capable,"dojo.widget.vml.Chart");

