dojo.provide("dojo.widget.DatePicker");
dojo.require("dojo.date.common");
dojo.require("dojo.date.format");
dojo.require("dojo.date.serialize");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.event.*");
dojo.require("dojo.dom");
dojo.require("dojo.html.style");
dojo.widget.defineWidget("dojo.widget.DatePicker",dojo.widget.HtmlWidget,{value:"",name:"",displayWeeks:6,adjustWeeks:false,startDate:"1492-10-12",endDate:"2941-10-12",weekStartsOn:"",storedDate:"",staticDisplay:false,dayWidth:"narrow",classNames:{previous:"previousMonth",disabledPrevious:"previousMonthDisabled",current:"currentMonth",disabledCurrent:"currentMonthDisabled",next:"nextMonth",disabledNext:"nextMonthDisabled",currentDate:"currentDate",selectedDate:"selectedItem"},templatePath:dojo.uri.dojoUri("src/widget/templates/DatePicker.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/DatePicker.css"),postMixInProperties:function(){
dojo.widget.DatePicker.superclass.postMixInProperties.apply(this,arguments);
if(this.storedDate){
dojo.deprecated("dojo.widget.DatePicker","use 'value' instead of 'storedDate'","0.5");
this.value=this.storedDate;
}
this.startDate=dojo.date.fromRfc3339(this.startDate);
this.endDate=dojo.date.fromRfc3339(this.endDate);
this.startDate.setHours(0,0,0,0);
this.endDate.setHours(24,0,0,-1);
if(!this.weekStartsOn){
this.weekStartsOn=dojo.date.getFirstDayOfWeek(this.lang);
}
this.today=new Date();
this.today.setHours(0,0,0,0);
if(typeof (this.value)=="string"&&this.value.toLowerCase()=="today"){
this.value=new Date();
}else{
if(this.value&&(typeof this.value=="string")&&(this.value.split("-").length>2)){
this.value=dojo.date.fromRfc3339(this.value);
this.value.setHours(0,0,0,0);
}
}
},fillInTemplate:function(_1,_2){
dojo.widget.DatePicker.superclass.fillInTemplate.apply(this,arguments);
var _3=this.getFragNodeRef(_2);
dojo.html.copyStyle(this.domNode,_3);
this.weekTemplate=dojo.dom.removeNode(this.calendarWeekTemplate);
this._preInitUI(this.value?this.value:this.today,false,true);
var _4=dojo.lang.unnest(dojo.date.getNames("days",this.dayWidth,"standAlone",this.lang));
if(this.weekStartsOn>0){
for(var i=0;i<this.weekStartsOn;i++){
_4.push(_4.shift());
}
}
var _6=this.dayLabelsRow.getElementsByTagName("td");
for(i=0;i<7;i++){
_6.item(i).innerHTML=_4[i];
}
if(this.value){
this.setValue(this.value);
}
},getValue:function(){
return dojo.date.toRfc3339(new Date(this.value),"dateOnly");
},getDate:function(){
return this.value;
},setValue:function(_7){
this.setDate(_7);
},setDate:function(_8){
if(typeof _8=="string"){
this.value=dojo.date.fromRfc3339(_8);
}else{
this.value=new Date(_8);
}
this.value.setHours(0,0,0,0);
if(this.selectedNode!=null){
dojo.html.removeClass(this.selectedNode,this.classNames.selectedDate);
}
if(this.clickedNode!=null){
dojo.html.addClass(this.clickedNode,this.classNames.selectedDate);
this.selectedNode=this.clickedNode;
}else{
this._preInitUI(this.value,false,true);
}
this.clickedNode=null;
this.onValueChanged(this.value);
},_preInitUI:function(_9,_a,_b){
if(_9<this.startDate||_9>this.endDate){
_9=new Date((_9<this.startDate)?this.startDate:this.endDate);
}
this.firstDay=this._initFirstDay(_9,_a);
this.selectedIsUsed=false;
this.currentIsUsed=false;
var _c=new Date(this.firstDay);
var _d=_c.getMonth();
this.curMonth=new Date(_c);
this.curMonth.setDate(_c.getDate()+6);
this.curMonth.setDate(1);
if(this.displayWeeks==""||this.adjustWeeks){
this.adjustWeeks=true;
this.displayWeeks=Math.ceil((dojo.date.getDaysInMonth(this.curMonth)+this._getAdjustedDay(this.curMonth))/7);
}
var _e=this.displayWeeks*7;
if(dojo.date.diff(this.startDate,this.endDate,dojo.date.dateParts.DAY)<_e){
this.staticDisplay=true;
if(dojo.date.diff(_c,this.endDate,dojo.date.dateParts.DAY)>_e){
this._preInitUI(this.startDate,true,false);
_c=new Date(this.firstDay);
}
this.curMonth=new Date(_c);
this.curMonth.setDate(_c.getDate()+6);
this.curMonth.setDate(1);
var _f=(_c.getMonth()==this.curMonth.getMonth())?"current":"previous";
}
if(_b){
this._initUI(_e);
}
},_initUI:function(_10){
dojo.dom.removeChildren(this.calendarDatesContainerNode);
for(var i=0;i<this.displayWeeks;i++){
this.calendarDatesContainerNode.appendChild(this.weekTemplate.cloneNode(true));
}
var _12=new Date(this.firstDay);
this._setMonthLabel(this.curMonth.getMonth());
this._setYearLabels(this.curMonth.getFullYear());
var _13=this.calendarDatesContainerNode.getElementsByTagName("td");
var _14=this.calendarDatesContainerNode.getElementsByTagName("tr");
var _15;
for(i=0;i<_10;i++){
_15=_13.item(i);
_15.innerHTML=_12.getDate();
var _16=(_12.getMonth()<this.curMonth.getMonth())?"previous":(_12.getMonth()==this.curMonth.getMonth())?"current":"next";
var _17=_16;
if(this._isDisabledDate(_12)){
var _18={previous:"disabledPrevious",current:"disabledCurrent",next:"disabledNext"};
_17=_18[_16];
}
dojo.html.setClass(_15,this._getDateClassName(_12,_17));
if(dojo.html.hasClass(_15,this.classNames.selectedDate)){
this.selectedNode=_15;
}
_12=dojo.date.add(_12,dojo.date.dateParts.DAY,1);
}
this.lastDay=dojo.date.add(_12,dojo.date.dateParts.DAY,-1);
this._initControls();
},_initControls:function(){
var d=this.firstDay;
var d2=this.lastDay;
var _1b,incWeek,decMonth,incMonth,decYear,incYear;
_1b=incWeek=decMonth=incMonth=decYear=incYear=!this.staticDisplay;
with(dojo.date.dateParts){
var add=dojo.date.add;
if(_1b&&add(d,DAY,(-1*(this._getAdjustedDay(d)+1)))<this.startDate){
_1b=decMonth=decYear=false;
}
if(incWeek&&d2>this.endDate){
incWeek=incMonth=incYear=false;
}
if(decMonth&&add(d,DAY,-1)<this.startDate){
decMonth=decYear=false;
}
if(incMonth&&add(d2,DAY,1)>this.endDate){
incMonth=incYear=false;
}
if(decYear&&add(d2,YEAR,-1)<this.startDate){
decYear=false;
}
if(incYear&&add(d,YEAR,1)>this.endDate){
incYear=false;
}
}
function enableControl(_1d,_1e){
dojo.html.setVisibility(_1d,_1e?"":"hidden");
}
enableControl(this.decreaseWeekNode,_1b);
enableControl(this.increaseWeekNode,incWeek);
enableControl(this.decreaseMonthNode,decMonth);
enableControl(this.increaseMonthNode,incMonth);
enableControl(this.previousYearLabelNode,decYear);
enableControl(this.nextYearLabelNode,incYear);
},_incrementWeek:function(evt){
var d=new Date(this.firstDay);
switch(evt.target){
case this.increaseWeekNode.getElementsByTagName("img").item(0):
case this.increaseWeekNode:
var _21=dojo.date.add(d,dojo.date.dateParts.WEEK,1);
if(_21<this.endDate){
d=dojo.date.add(d,dojo.date.dateParts.WEEK,1);
}
break;
case this.decreaseWeekNode.getElementsByTagName("img").item(0):
case this.decreaseWeekNode:
if(d>=this.startDate){
d=dojo.date.add(d,dojo.date.dateParts.WEEK,-1);
}
break;
}
this._preInitUI(d,true,true);
},_incrementMonth:function(evt){
var d=new Date(this.curMonth);
var _24=new Date(this.firstDay);
switch(evt.currentTarget){
case this.increaseMonthNode.getElementsByTagName("img").item(0):
case this.increaseMonthNode:
_24=dojo.date.add(_24,dojo.date.dateParts.DAY,this.displayWeeks*7);
if(_24<this.endDate){
d=dojo.date.add(d,dojo.date.dateParts.MONTH,1);
}else{
var _25=true;
}
break;
case this.decreaseMonthNode.getElementsByTagName("img").item(0):
case this.decreaseMonthNode:
if(_24>this.startDate){
d=dojo.date.add(d,dojo.date.dateParts.MONTH,-1);
}else{
var _26=true;
}
break;
}
if(_26){
d=new Date(this.startDate);
}else{
if(_25){
d=new Date(this.endDate);
}
}
this._preInitUI(d,false,true);
},_incrementYear:function(evt){
var _28=this.curMonth.getFullYear();
var _29=new Date(this.firstDay);
switch(evt.target){
case this.nextYearLabelNode:
_29=dojo.date.add(_29,dojo.date.dateParts.YEAR,1);
if(_29<this.endDate){
_28++;
}else{
var _2a=true;
}
break;
case this.previousYearLabelNode:
_29=dojo.date.add(_29,dojo.date.dateParts.YEAR,-1);
if(_29>this.startDate){
_28--;
}else{
var _2b=true;
}
break;
}
var d;
if(_2b){
d=new Date(this.startDate);
}else{
if(_2a){
d=new Date(this.endDate);
}else{
d=new Date(_28,this.curMonth.getMonth(),1);
}
}
this._preInitUI(d,false,true);
},onIncrementWeek:function(evt){
evt.stopPropagation();
if(!this.staticDisplay){
this._incrementWeek(evt);
}
},onIncrementMonth:function(evt){
evt.stopPropagation();
if(!this.staticDisplay){
this._incrementMonth(evt);
}
},onIncrementYear:function(evt){
evt.stopPropagation();
if(!this.staticDisplay){
this._incrementYear(evt);
}
},_setMonthLabel:function(_30){
this.monthLabelNode.innerHTML=dojo.date.getNames("months","wide","standAlone",this.lang)[_30];
},_setYearLabels:function(_31){
var y=_31-1;
var _33=this;
function f(n){
_33[n+"YearLabelNode"].innerHTML=dojo.date.format(new Date(y++,0),{formatLength:"yearOnly",locale:_33.lang});
}
f("previous");
f("current");
f("next");
},_getDateClassName:function(_35,_36){
var _37=this.classNames[_36];
if((!this.selectedIsUsed&&this.value)&&(Number(_35)==Number(this.value))){
_37=this.classNames.selectedDate+" "+_37;
this.selectedIsUsed=true;
}
if((!this.currentIsUsed)&&(Number(_35)==Number(this.today))){
_37=_37+" "+this.classNames.currentDate;
this.currentIsUsed=true;
}
return _37;
},onClick:function(evt){
dojo.event.browser.stopEvent(evt);
},_handleUiClick:function(evt){
var _3a=evt.target;
if(_3a.nodeType!=dojo.dom.ELEMENT_NODE){
_3a=_3a.parentNode;
}
dojo.event.browser.stopEvent(evt);
this.selectedIsUsed=this.todayIsUsed=false;
var _3b=this.curMonth.getMonth();
var _3c=this.curMonth.getFullYear();
if(dojo.html.hasClass(_3a,this.classNames["disabledPrevious"])||dojo.html.hasClass(_3a,this.classNames["disabledCurrent"])||dojo.html.hasClass(_3a,this.classNames["disabledNext"])){
return;
}else{
if(dojo.html.hasClass(_3a,this.classNames["next"])){
_3b=++_3b%12;
if(_3b===0){
++_3c;
}
}else{
if(dojo.html.hasClass(_3a,this.classNames["previous"])){
_3b=--_3b%12;
if(_3b==11){
--_3c;
}
}
}
}
this.clickedNode=_3a;
this.setDate(new Date(_3c,_3b,_3a.innerHTML));
},onValueChanged:function(_3d){
},_isDisabledDate:function(_3e){
if(_3e<this.startDate||_3e>this.endDate){
return true;
}
return this.isDisabledDate(_3e,this.lang);
},isDisabledDate:function(_3f,_40){
return false;
},_initFirstDay:function(_41,adj){
var d=new Date(_41);
if(!adj){
d.setDate(1);
}
d.setDate(d.getDate()-this._getAdjustedDay(d,this.weekStartsOn));
d.setHours(0,0,0,0);
return d;
},_getAdjustedDay:function(_44){
var _45=[0,1,2,3,4,5,6];
if(this.weekStartsOn>0){
for(var i=0;i<this.weekStartsOn;i++){
_45.unshift(_45.pop());
}
}
return _45[_44.getDay()];
},destroy:function(){
dojo.widget.DatePicker.superclass.destroy.apply(this,arguments);
dojo.html.destroyNode(this.weekTemplate);
}});

