dojo.provide("dojo.widget.Editor2Toolbar");
dojo.require("dojo.lang.*");
dojo.require("dojo.widget.*");
dojo.require("dojo.event.*");
dojo.require("dojo.html.layout");
dojo.require("dojo.html.display");
dojo.require("dojo.widget.RichText");
dojo.require("dojo.widget.PopupContainer");
dojo.require("dojo.widget.ColorPalette");
dojo.lang.declare("dojo.widget.HandlerManager",null,function(){
this._registeredHandlers=[];
},{registerHandler:function(_1,_2){
if(arguments.length==2){
this._registeredHandlers.push(function(){
return _1[_2].apply(_1,arguments);
});
}else{
this._registeredHandlers.push(_1);
}
},removeHandler:function(_3){
for(var i=0;i<this._registeredHandlers.length;i++){
if(_3===this._registeredHandlers[i]){
delete this._registeredHandlers[i];
return;
}
}
dojo.debug("HandlerManager handler "+_3+" is not registered, can not remove.");
},destroy:function(){
for(var i=0;i<this._registeredHandlers.length;i++){
delete this._registeredHandlers[i];
}
}});
dojo.widget.Editor2ToolbarItemManager=new dojo.widget.HandlerManager;
dojo.lang.mixin(dojo.widget.Editor2ToolbarItemManager,{getToolbarItem:function(_6){
var _7;
_6=_6.toLowerCase();
for(var i=0;i<this._registeredHandlers.length;i++){
_7=this._registeredHandlers[i](_6);
if(_7){
return _7;
}
}
switch(_6){
case "bold":
case "copy":
case "cut":
case "delete":
case "indent":
case "inserthorizontalrule":
case "insertorderedlist":
case "insertunorderedlist":
case "italic":
case "justifycenter":
case "justifyfull":
case "justifyleft":
case "justifyright":
case "outdent":
case "paste":
case "redo":
case "removeformat":
case "selectall":
case "strikethrough":
case "subscript":
case "superscript":
case "underline":
case "undo":
case "unlink":
case "createlink":
case "insertimage":
case "htmltoggle":
_7=new dojo.widget.Editor2ToolbarButton(_6);
break;
case "forecolor":
case "hilitecolor":
_7=new dojo.widget.Editor2ToolbarColorPaletteButton(_6);
break;
case "plainformatblock":
_7=new dojo.widget.Editor2ToolbarFormatBlockPlainSelect("formatblock");
break;
case "formatblock":
_7=new dojo.widget.Editor2ToolbarFormatBlockSelect("formatblock");
break;
case "fontsize":
_7=new dojo.widget.Editor2ToolbarFontSizeSelect("fontsize");
break;
case "fontname":
_7=new dojo.widget.Editor2ToolbarFontNameSelect("fontname");
break;
case "inserttable":
case "insertcell":
case "insertcol":
case "insertrow":
case "deletecells":
case "deletecols":
case "deleterows":
case "mergecells":
case "splitcell":
dojo.debug(_6+" is implemented in dojo.widget.Editor2Plugin.TableOperation, please require it first.");
break;
case "inserthtml":
case "blockdirltr":
case "blockdirrtl":
case "dirltr":
case "dirrtl":
case "inlinedirltr":
case "inlinedirrtl":
dojo.debug("Not yet implemented toolbar item: "+_6);
break;
default:
dojo.debug("dojo.widget.Editor2ToolbarItemManager.getToolbarItem: Unknown toolbar item: "+_6);
}
return _7;
}});
dojo.addOnUnload(dojo.widget.Editor2ToolbarItemManager,"destroy");
dojo.declare("dojo.widget.Editor2ToolbarButton",null,function(_9){
this._name=_9;
},{create:function(_a,_b,_c){
this._domNode=_a;
var _d=_b.parent.getCommand(this._name);
if(_d){
this._domNode.title=_d.getText();
}
this.disableSelection(this._domNode);
this._parentToolbar=_b;
dojo.event.connect(this._domNode,"onclick",this,"onClick");
if(!_c){
dojo.event.connect(this._domNode,"onmouseover",this,"onMouseOver");
dojo.event.connect(this._domNode,"onmouseout",this,"onMouseOut");
}
},disableSelection:function(_e){
dojo.html.disableSelection(_e);
var _f=_e.all||_e.getElementsByTagName("*");
for(var x=0;x<_f.length;x++){
dojo.html.disableSelection(_f[x]);
}
},onMouseOver:function(){
var _11=dojo.widget.Editor2Manager.getCurrentInstance();
if(_11){
var _12=_11.getCommand(this._name);
if(_12&&_12.getState()!=dojo.widget.Editor2Manager.commandState.Disabled){
this.highlightToolbarItem();
}
}
},onMouseOut:function(){
this.unhighlightToolbarItem();
},destroy:function(){
this._domNode=null;
this._parentToolbar=null;
},onClick:function(e){
if(this._domNode&&!this._domNode.disabled&&this._parentToolbar.checkAvailability()){
e.preventDefault();
e.stopPropagation();
var _14=dojo.widget.Editor2Manager.getCurrentInstance();
if(_14){
var _15=_14.getCommand(this._name);
if(_15){
_15.execute();
}
}
}
},refreshState:function(){
var _16=dojo.widget.Editor2Manager.getCurrentInstance();
var em=dojo.widget.Editor2Manager;
if(_16){
var _18=_16.getCommand(this._name);
if(_18){
var _19=_18.getState();
if(_19!=this._lastState){
switch(_19){
case em.commandState.Latched:
this.latchToolbarItem();
break;
case em.commandState.Enabled:
this.enableToolbarItem();
break;
case em.commandState.Disabled:
default:
this.disableToolbarItem();
}
this._lastState=_19;
}
}
}
return em.commandState.Enabled;
},latchToolbarItem:function(){
this._domNode.disabled=false;
this.removeToolbarItemStyle(this._domNode);
dojo.html.addClass(this._domNode,this._parentToolbar.ToolbarLatchedItemStyle);
},enableToolbarItem:function(){
this._domNode.disabled=false;
this.removeToolbarItemStyle(this._domNode);
dojo.html.addClass(this._domNode,this._parentToolbar.ToolbarEnabledItemStyle);
},disableToolbarItem:function(){
this._domNode.disabled=true;
this.removeToolbarItemStyle(this._domNode);
dojo.html.addClass(this._domNode,this._parentToolbar.ToolbarDisabledItemStyle);
},highlightToolbarItem:function(){
dojo.html.addClass(this._domNode,this._parentToolbar.ToolbarHighlightedItemStyle);
},unhighlightToolbarItem:function(){
dojo.html.removeClass(this._domNode,this._parentToolbar.ToolbarHighlightedItemStyle);
},removeToolbarItemStyle:function(){
dojo.html.removeClass(this._domNode,this._parentToolbar.ToolbarEnabledItemStyle);
dojo.html.removeClass(this._domNode,this._parentToolbar.ToolbarLatchedItemStyle);
dojo.html.removeClass(this._domNode,this._parentToolbar.ToolbarDisabledItemStyle);
this.unhighlightToolbarItem();
}});
dojo.declare("dojo.widget.Editor2ToolbarDropDownButton",dojo.widget.Editor2ToolbarButton,{onClick:function(){
if(this._domNode&&!this._domNode.disabled&&this._parentToolbar.checkAvailability()){
if(!this._dropdown){
this._dropdown=dojo.widget.createWidget("PopupContainer",{});
this._domNode.appendChild(this._dropdown.domNode);
}
if(this._dropdown.isShowingNow){
this._dropdown.close();
}else{
this.onDropDownShown();
this._dropdown.open(this._domNode,null,this._domNode);
}
}
},destroy:function(){
this.onDropDownDestroy();
if(this._dropdown){
this._dropdown.destroy();
}
dojo.widget.Editor2ToolbarDropDownButton.superclass.destroy.call(this);
},onDropDownShown:function(){
},onDropDownDestroy:function(){
}});
dojo.declare("dojo.widget.Editor2ToolbarColorPaletteButton",dojo.widget.Editor2ToolbarDropDownButton,{onDropDownShown:function(){
if(!this._colorpalette){
this._colorpalette=dojo.widget.createWidget("ColorPalette",{});
this._dropdown.addChild(this._colorpalette);
this.disableSelection(this._dropdown.domNode);
this.disableSelection(this._colorpalette.domNode);
dojo.event.connect(this._colorpalette,"onColorSelect",this,"setColor");
dojo.event.connect(this._dropdown,"open",this,"latchToolbarItem");
dojo.event.connect(this._dropdown,"close",this,"enableToolbarItem");
}
},setColor:function(_1a){
this._dropdown.close();
var _1b=dojo.widget.Editor2Manager.getCurrentInstance();
if(_1b){
var _1c=_1b.getCommand(this._name);
if(_1c){
_1c.execute(_1a);
}
}
}});
dojo.declare("dojo.widget.Editor2ToolbarFormatBlockPlainSelect",dojo.widget.Editor2ToolbarButton,{create:function(_1d,_1e){
this._domNode=_1d;
this._parentToolbar=_1e;
this._domNode=_1d;
this.disableSelection(this._domNode);
dojo.event.connect(this._domNode,"onchange",this,"onChange");
},destroy:function(){
this._domNode=null;
},onChange:function(){
if(this._parentToolbar.checkAvailability()){
var sv=this._domNode.value.toLowerCase();
var _20=dojo.widget.Editor2Manager.getCurrentInstance();
if(_20){
var _21=_20.getCommand(this._name);
if(_21){
_21.execute(sv);
}
}
}
},refreshState:function(){
if(this._domNode){
dojo.widget.Editor2ToolbarFormatBlockPlainSelect.superclass.refreshState.call(this);
var _22=dojo.widget.Editor2Manager.getCurrentInstance();
if(_22){
var _23=_22.getCommand(this._name);
if(_23){
var _24=_23.getValue();
if(!_24){
_24="";
}
dojo.lang.forEach(this._domNode.options,function(_25){
if(_25.value.toLowerCase()==_24.toLowerCase()){
_25.selected=true;
}
});
}
}
}
}});
dojo.declare("dojo.widget.Editor2ToolbarComboItem",dojo.widget.Editor2ToolbarDropDownButton,{href:null,create:function(_26,_27){
dojo.widget.Editor2ToolbarComboItem.superclass.create.apply(this,arguments);
if(!this._contentPane){
dojo.require("dojo.widget.ContentPane");
this._contentPane=dojo.widget.createWidget("ContentPane",{preload:"true"});
this._contentPane.addOnLoad(this,"setup");
this._contentPane.setUrl(this.href);
}
},onMouseOver:function(e){
if(this._lastState!=dojo.widget.Editor2Manager.commandState.Disabled){
dojo.html.addClass(e.currentTarget,this._parentToolbar.ToolbarHighlightedSelectStyle);
}
},onMouseOut:function(e){
dojo.html.removeClass(e.currentTarget,this._parentToolbar.ToolbarHighlightedSelectStyle);
},onDropDownShown:function(){
if(!this._dropdown.__addedContentPage){
this._dropdown.addChild(this._contentPane);
this._dropdown.__addedContentPage=true;
}
},setup:function(){
},onChange:function(e){
if(this._parentToolbar.checkAvailability()){
var _2b=e.currentTarget.getAttribute("dropDownItemName");
var _2c=dojo.widget.Editor2Manager.getCurrentInstance();
if(_2c){
var _2d=_2c.getCommand(this._name);
if(_2d){
_2d.execute(_2b);
}
}
}
this._dropdown.close();
},onMouseOverItem:function(e){
dojo.html.addClass(e.currentTarget,this._parentToolbar.ToolbarHighlightedSelectItemStyle);
},onMouseOutItem:function(e){
dojo.html.removeClass(e.currentTarget,this._parentToolbar.ToolbarHighlightedSelectItemStyle);
}});
dojo.declare("dojo.widget.Editor2ToolbarFormatBlockSelect",dojo.widget.Editor2ToolbarComboItem,{href:dojo.uri.dojoUri("src/widget/templates/Editor2/EditorToolbar_FormatBlock.html"),setup:function(){
dojo.widget.Editor2ToolbarFormatBlockSelect.superclass.setup.call(this);
var _30=this._contentPane.domNode.all||this._contentPane.domNode.getElementsByTagName("*");
this._blockNames={};
this._blockDisplayNames={};
for(var x=0;x<_30.length;x++){
var _32=_30[x];
dojo.html.disableSelection(_32);
var _33=_32.getAttribute("dropDownItemName");
if(_33){
this._blockNames[_33]=_32;
var _34=_32.getElementsByTagName(_33);
this._blockDisplayNames[_33]=_34[_34.length-1].innerHTML;
}
}
for(var _33 in this._blockNames){
dojo.event.connect(this._blockNames[_33],"onclick",this,"onChange");
dojo.event.connect(this._blockNames[_33],"onmouseover",this,"onMouseOverItem");
dojo.event.connect(this._blockNames[_33],"onmouseout",this,"onMouseOutItem");
}
},onDropDownDestroy:function(){
if(this._blockNames){
for(var _35 in this._blockNames){
delete this._blockNames[_35];
delete this._blockDisplayNames[_35];
}
}
},refreshState:function(){
dojo.widget.Editor2ToolbarFormatBlockSelect.superclass.refreshState.call(this);
if(this._lastState!=dojo.widget.Editor2Manager.commandState.Disabled){
var _36=dojo.widget.Editor2Manager.getCurrentInstance();
if(_36){
var _37=_36.getCommand(this._name);
if(_37){
var _38=_37.getValue();
if(_38==this._lastSelectedFormat&&this._blockDisplayNames){
return this._lastState;
}
this._lastSelectedFormat=_38;
var _39=this._domNode.getElementsByTagName("label")[0];
var _3a=false;
if(this._blockDisplayNames){
for(var _3b in this._blockDisplayNames){
if(_3b==_38){
_39.innerHTML=this._blockDisplayNames[_3b];
_3a=true;
break;
}
}
if(!_3a){
_39.innerHTML="&nbsp;";
}
}
}
}
}
return this._lastState;
}});
dojo.declare("dojo.widget.Editor2ToolbarFontSizeSelect",dojo.widget.Editor2ToolbarComboItem,{href:dojo.uri.dojoUri("src/widget/templates/Editor2/EditorToolbar_FontSize.html"),setup:function(){
dojo.widget.Editor2ToolbarFormatBlockSelect.superclass.setup.call(this);
var _3c=this._contentPane.domNode.all||this._contentPane.domNode.getElementsByTagName("*");
this._fontsizes={};
this._fontSizeDisplayNames={};
for(var x=0;x<_3c.length;x++){
var _3e=_3c[x];
dojo.html.disableSelection(_3e);
var _3f=_3e.getAttribute("dropDownItemName");
if(_3f){
this._fontsizes[_3f]=_3e;
this._fontSizeDisplayNames[_3f]=_3e.getElementsByTagName("font")[0].innerHTML;
}
}
for(var _3f in this._fontsizes){
dojo.event.connect(this._fontsizes[_3f],"onclick",this,"onChange");
dojo.event.connect(this._fontsizes[_3f],"onmouseover",this,"onMouseOverItem");
dojo.event.connect(this._fontsizes[_3f],"onmouseout",this,"onMouseOutItem");
}
},onDropDownDestroy:function(){
if(this._fontsizes){
for(var _40 in this._fontsizes){
delete this._fontsizes[_40];
delete this._fontSizeDisplayNames[_40];
}
}
},refreshState:function(){
dojo.widget.Editor2ToolbarFormatBlockSelect.superclass.refreshState.call(this);
if(this._lastState!=dojo.widget.Editor2Manager.commandState.Disabled){
var _41=dojo.widget.Editor2Manager.getCurrentInstance();
if(_41){
var _42=_41.getCommand(this._name);
if(_42){
var _43=_42.getValue();
if(_43==this._lastSelectedSize&&this._fontSizeDisplayNames){
return this._lastState;
}
this._lastSelectedSize=_43;
var _44=this._domNode.getElementsByTagName("label")[0];
var _45=false;
if(this._fontSizeDisplayNames){
for(var _46 in this._fontSizeDisplayNames){
if(_46==_43){
_44.innerHTML=this._fontSizeDisplayNames[_46];
_45=true;
break;
}
}
if(!_45){
_44.innerHTML="&nbsp;";
}
}
}
}
}
return this._lastState;
}});
dojo.declare("dojo.widget.Editor2ToolbarFontNameSelect",dojo.widget.Editor2ToolbarFontSizeSelect,{href:dojo.uri.dojoUri("src/widget/templates/Editor2/EditorToolbar_FontName.html")});
dojo.widget.defineWidget("dojo.widget.Editor2Toolbar",dojo.widget.HtmlWidget,function(){
dojo.event.connect(this,"fillInTemplate",dojo.lang.hitch(this,function(){
if(dojo.render.html.ie){
this.domNode.style.zoom=1;
}
}));
},{templatePath:dojo.uri.dojoUri("src/widget/templates/EditorToolbar.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/EditorToolbar.css"),ToolbarLatchedItemStyle:"ToolbarButtonLatched",ToolbarEnabledItemStyle:"ToolbarButtonEnabled",ToolbarDisabledItemStyle:"ToolbarButtonDisabled",ToolbarHighlightedItemStyle:"ToolbarButtonHighlighted",ToolbarHighlightedSelectStyle:"ToolbarSelectHighlighted",ToolbarHighlightedSelectItemStyle:"ToolbarSelectHighlightedItem",postCreate:function(){
var _47=dojo.html.getElementsByClass("dojoEditorToolbarItem",this.domNode);
this.items={};
for(var x=0;x<_47.length;x++){
var _49=_47[x];
var _4a=_49.getAttribute("dojoETItemName");
if(_4a){
var _4b=dojo.widget.Editor2ToolbarItemManager.getToolbarItem(_4a);
if(_4b){
_4b.create(_49,this);
this.items[_4a.toLowerCase()]=_4b;
}else{
_49.style.display="none";
}
}
}
},update:function(){
for(var cmd in this.items){
this.items[cmd].refreshState();
}
},shareGroup:"",checkAvailability:function(){
if(!this.shareGroup){
this.parent.focus();
return true;
}
var _4d=dojo.widget.Editor2Manager.getCurrentInstance();
if(this.shareGroup==_4d.toolbarGroup){
return true;
}
return false;
},destroy:function(){
for(var it in this.items){
this.items[it].destroy();
delete this.items[it];
}
dojo.widget.Editor2Toolbar.superclass.destroy.call(this);
}});

