dojo.provide("dojo.widget.TimePicker");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.HtmlWidget");
dojo.require("dojo.event.*");
dojo.require("dojo.date.serialize");
dojo.require("dojo.date.format");
dojo.require("dojo.dom");
dojo.require("dojo.html.style");
dojo.requireLocalization("dojo.i18n.calendar","gregorian",null,"de,en,es,fi,fr,hu,ja,it,ko,nl,pt,sv,zh,pt-br,zh-cn,zh-hk,zh-tw,ROOT");
dojo.requireLocalization("dojo.widget","TimePicker",null,"ROOT");
dojo.widget.defineWidget("dojo.widget.TimePicker",dojo.widget.HtmlWidget,function(){
this.time="";
this.useDefaultTime=false;
this.useDefaultMinutes=false;
this.storedTime="";
this.currentTime={};
this.classNames={selectedTime:"selectedItem"};
this.any="any";
this.selectedTime={hour:"",minute:"",amPm:"",anyTime:false};
this.hourIndexMap=["",2,4,6,8,10,1,3,5,7,9,11,0];
this.minuteIndexMap=[0,2,4,6,8,10,1,3,5,7,9,11];
},{isContainer:false,templatePath:dojo.uri.dojoUri("src/widget/templates/TimePicker.html"),templateCssPath:dojo.uri.dojoUri("src/widget/templates/TimePicker.css"),postMixInProperties:function(_1,_2){
dojo.widget.TimePicker.superclass.postMixInProperties.apply(this,arguments);
this.calendar=dojo.i18n.getLocalization("dojo.i18n.calendar","gregorian",this.lang);
this.widgetStrings=dojo.i18n.getLocalization("dojo.widget","TimePicker",this.lang);
},fillInTemplate:function(_3,_4){
var _5=this.getFragNodeRef(_4);
dojo.html.copyStyle(this.domNode,_5);
if(_3.value){
if(_3.value instanceof Date){
this.storedTime=dojo.date.toRfc3339(_3.value);
}else{
this.storedTime=_3.value;
}
}
this.initData();
this.initUI();
},initData:function(){
if(this.storedTime.indexOf("T")!=-1&&this.storedTime.split("T")[1]&&this.storedTime!=" "&&this.storedTime.split("T")[1]!="any"){
this.time=dojo.widget.TimePicker.util.fromRfcDateTime(this.storedTime,this.useDefaultMinutes,this.selectedTime.anyTime);
}else{
if(this.useDefaultTime){
this.time=dojo.widget.TimePicker.util.fromRfcDateTime("",this.useDefaultMinutes,this.selectedTime.anyTime);
}else{
this.selectedTime.anyTime=true;
this.time=dojo.widget.TimePicker.util.fromRfcDateTime("",0,1);
}
}
},initUI:function(){
if(!this.selectedTime.anyTime&&this.time){
var _6=dojo.widget.TimePicker.util.toAmPmHour(this.time.getHours());
var _7=_6[0];
var _8=_6[1];
var _9=this.time.getMinutes();
var _a=parseInt(_9/5);
this.onSetSelectedHour(this.hourIndexMap[_7]);
this.onSetSelectedMinute(this.minuteIndexMap[_a]);
this.onSetSelectedAmPm(_8);
}else{
this.onSetSelectedAnyTime();
}
},setTime:function(_b){
if(_b){
this.selectedTime.anyTime=false;
this.setDateTime(dojo.date.toRfc3339(_b));
}else{
this.selectedTime.anyTime=true;
}
this.initData();
this.initUI();
},setDateTime:function(_c){
this.storedTime=_c;
},onClearSelectedHour:function(_d){
this.clearSelectedHour();
},onClearSelectedMinute:function(_e){
this.clearSelectedMinute();
},onClearSelectedAmPm:function(_f){
this.clearSelectedAmPm();
},onClearSelectedAnyTime:function(evt){
this.clearSelectedAnyTime();
if(this.selectedTime.anyTime){
this.selectedTime.anyTime=false;
this.time=dojo.widget.TimePicker.util.fromRfcDateTime("",this.useDefaultMinutes);
this.initUI();
}
},clearSelectedHour:function(){
var _11=this.hourContainerNode.getElementsByTagName("td");
for(var i=0;i<_11.length;i++){
dojo.html.setClass(_11.item(i),"");
}
},clearSelectedMinute:function(){
var _13=this.minuteContainerNode.getElementsByTagName("td");
for(var i=0;i<_13.length;i++){
dojo.html.setClass(_13.item(i),"");
}
},clearSelectedAmPm:function(){
var _15=this.amPmContainerNode.getElementsByTagName("td");
for(var i=0;i<_15.length;i++){
dojo.html.setClass(_15.item(i),"");
}
},clearSelectedAnyTime:function(){
dojo.html.setClass(this.anyTimeContainerNode,"anyTimeContainer");
},onSetSelectedHour:function(evt){
this.onClearSelectedAnyTime();
this.onClearSelectedHour();
this.setSelectedHour(evt);
this.onSetTime();
},setSelectedHour:function(evt){
if(evt&&evt.target){
if(evt.target.nodeType==dojo.dom.ELEMENT_NODE){
var _19=evt.target;
}else{
var _19=evt.target.parentNode;
}
dojo.event.browser.stopEvent(evt);
dojo.html.setClass(_19,this.classNames.selectedTime);
this.selectedTime["hour"]=_19.innerHTML;
}else{
if(!isNaN(evt)){
var _1a=this.hourContainerNode.getElementsByTagName("td");
if(_1a.item(evt)){
dojo.html.setClass(_1a.item(evt),this.classNames.selectedTime);
this.selectedTime["hour"]=_1a.item(evt).innerHTML;
}
}
}
this.selectedTime.anyTime=false;
},onSetSelectedMinute:function(evt){
this.onClearSelectedAnyTime();
this.onClearSelectedMinute();
this.setSelectedMinute(evt);
this.selectedTime.anyTime=false;
this.onSetTime();
},setSelectedMinute:function(evt){
if(evt&&evt.target){
if(evt.target.nodeType==dojo.dom.ELEMENT_NODE){
var _1d=evt.target;
}else{
var _1d=evt.target.parentNode;
}
dojo.event.browser.stopEvent(evt);
dojo.html.setClass(_1d,this.classNames.selectedTime);
this.selectedTime["minute"]=_1d.innerHTML;
}else{
if(!isNaN(evt)){
var _1e=this.minuteContainerNode.getElementsByTagName("td");
if(_1e.item(evt)){
dojo.html.setClass(_1e.item(evt),this.classNames.selectedTime);
this.selectedTime["minute"]=_1e.item(evt).innerHTML;
}
}
}
},onSetSelectedAmPm:function(evt){
this.onClearSelectedAnyTime();
this.onClearSelectedAmPm();
this.setSelectedAmPm(evt);
this.selectedTime.anyTime=false;
this.onSetTime();
},setSelectedAmPm:function(evt){
var _21=evt.target;
if(evt&&_21){
if(_21.nodeType!=dojo.dom.ELEMENT_NODE){
_21=_21.parentNode;
}
dojo.event.browser.stopEvent(evt);
this.selectedTime.amPm=_21.id;
dojo.html.setClass(_21,this.classNames.selectedTime);
}else{
evt=evt?0:1;
var _22=this.amPmContainerNode.getElementsByTagName("td");
if(_22.item(evt)){
this.selectedTime.amPm=_22.item(evt).id;
dojo.html.setClass(_22.item(evt),this.classNames.selectedTime);
}
}
},onSetSelectedAnyTime:function(evt){
this.onClearSelectedHour();
this.onClearSelectedMinute();
this.onClearSelectedAmPm();
this.setSelectedAnyTime();
this.onSetTime();
},setSelectedAnyTime:function(evt){
this.selectedTime.anyTime=true;
dojo.html.setClass(this.anyTimeContainerNode,this.classNames.selectedTime+" "+"anyTimeContainer");
},onClick:function(evt){
dojo.event.browser.stopEvent(evt);
},onSetTime:function(){
if(this.selectedTime.anyTime){
this.time=new Date();
var _26=dojo.widget.TimePicker.util.toRfcDateTime(this.time);
this.setDateTime(_26.split("T")[0]);
}else{
var _27=12;
var _28=0;
var _29=false;
if(this.selectedTime["hour"]){
_27=parseInt(this.selectedTime["hour"],10);
}
if(this.selectedTime["minute"]){
_28=parseInt(this.selectedTime["minute"],10);
}
if(this.selectedTime["amPm"]){
_29=(this.selectedTime["amPm"].toLowerCase()=="am");
}
this.time=new Date();
this.time.setHours(dojo.widget.TimePicker.util.fromAmPmHour(_27,_29));
this.time.setMinutes(_28);
this.setDateTime(dojo.widget.TimePicker.util.toRfcDateTime(this.time));
}
this.onValueChanged(this.time);
},onValueChanged:function(_2a){
}});
dojo.widget.TimePicker.util=new function(){
this.toRfcDateTime=function(_2b){
if(!_2b){
_2b=new Date();
}
_2b.setSeconds(0);
return dojo.date.strftime(_2b,"%Y-%m-%dT%H:%M:00%z");
};
this.fromRfcDateTime=function(_2c,_2d,_2e){
var _2f=new Date();
if(!_2c||_2c.indexOf("T")==-1){
if(_2d){
_2f.setMinutes(Math.floor(_2f.getMinutes()/5)*5);
}else{
_2f.setMinutes(0);
}
}else{
var _30=_2c.split("T")[1].split(":");
var _2f=new Date();
_2f.setHours(_30[0]);
_2f.setMinutes(_30[1]);
}
return _2f;
};
this.toAmPmHour=function(_31){
var _32=_31;
var _33=true;
if(_32==0){
_32=12;
}else{
if(_32>12){
_32=_32-12;
_33=false;
}else{
if(_32==12){
_33=false;
}
}
}
return [_32,_33];
};
this.fromAmPmHour=function(_34,_35){
var _36=parseInt(_34,10);
if(_35&&_36==12){
_36=0;
}else{
if(!_35&&_36<12){
_36=_36+12;
}
}
return _36;
};
};

